# 開発メモ
## コルーチン
Luaはマルチスレッドで動作させることができません。
そのためloopライブラリではコルーチンにより順番に処理を実行するようになっていますが、yieldによりコルーチンの動作を中断しないと他の処理が実行されないということになります。
ConsoleIn.luaのサンプルを試してみたら分かりますが、標準入力等で動作を止めてしまうと、ほかの処理も実行されず完全に停止します。
このためRTSystemEditorからの操作もできません。

## OiLのバージョン
OiLの最新版は2017年9月にリリースされた0.7.0なので、0.4はかなり古いです。最新版ではSSLの通信もできるらしいです。
ただLua for Windowsでインストールするのが簡単なので、0.4でとりあえず実装はしてあります。
Lua自体も5.1.5は古いので、5.2系には移行したいと思います。OiLの0.7系への対応もそのうちやります。

※ver.0.3.1でOiL 0.7、Lua 5.2.4に対応しました。

## Windows版LuaRocks

WindowsではOiLのインストールが上手くいかない。おそらくCのバイナリ生成時の問題。
luaidlのインストールはできるが、OiLのバージョンが0.4betaのままでluaidlだけ新しいバージョンに移行すると不具合が発生する。

lualoggingのインストールにも失敗するが、この原因は一切不明。

OiLもlualoggingもLua for Windowsに最初から入っているものを使えばいいため、現状問題は無い。

## OiL 0.7の問題

OiL 0.7は何故かoil.VERSIONで取得できるバージョンが0.6になっている。

また、Codec.luaのstruct関数455目に以下を追加しないと落ちることがある。

<pre>
if field.name == "port" then
	val = tonumber(val)
end
</pre>

## ARMの問題
ARMアーキテクチャで動作させたときにFloat型、Double型のアンマーシャリングが失敗する。Raspbian、ev3devでは発生するが、Windows 10 IoTでは発生しない。これだからLinuxは困る。
この問題はOiL-0.5.2以前のバージョンの問題であるため、ARMアーキテクチャで動作させる場合はOiL-0.7のインストールが必要。
